//
//  DetailViewController.m
//  assignment3
//
//  Created by Ninglin Li on 5/10/13.
//  Copyright (c) 2013 Ninglin_Li. All rights reserved.
// this class show the detailview which has the photo that user choose from photo libiary
//  or camera and a series of thumbnail of this image with filter effect 
//  user can draw on the photo or add filter effect or share the image with friends via facebook 
//  or save the image into this app.

#import "DetailViewController.h"
#import "ILSideScrollViewItem.h"
#import "DetailInfoViewController.h"
#import <Social/Social.h>


@interface DetailViewController ()

@end

@implementation DetailViewController{
    NSMutableArray *items;
    UIImage * addImage;
}

// show user choosed image into center view
// show scrollerview with all thumbnail 
- (void)viewDidLoad
{
    [super viewDidLoad];
    self.targetImage.image = self.passedImage;
    NSLog(@"self.passedImage %@", self.passedImage);
	
    // setup scroller for filter
    self.scroller = [[ILSideScrollView alloc] initWithFrame:CGRectMake(0, 325, 320, 90)];
    [self.scroller setBackgroundColor:[UIColor grayColor] indicatorStyle:UIScrollViewIndicatorStyleWhite itemBorderColor:[UIColor grayColor]];
    [self.view addSubview:self.scroller];
    [self setScrollView];
    //setup button controller
    self.radialMenu = [[ALRadialMenu alloc] init];
	self.radialMenu.delegate = self;
    
    self.targetImage.userInteractionEnabled = YES;
    UITapGestureRecognizer *oneTouch=[[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(tagToAddImage:)];
    
    [oneTouch setNumberOfTouchesRequired:1];
    
    [self.targetImage addGestureRecognizer:oneTouch];
}

- (void)viewDidAppear:(BOOL)animated{
    
//    [self findFaces:self.targetImage];
}

#pragma mark scrolView and filter
// set up scrollview with all thumbnail

- (void)setScrollView{
    CGSize destinationSize = CGSizeMake(80.0, 80.0);
    UIGraphicsBeginImageContext(destinationSize);
    [self.passedImage drawInRect:CGRectMake(0,0,destinationSize.width,destinationSize.height)];
    UIImage *image0 = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    // get image with filter effect
    UIImage *image1 = [self sepia:image0];
    UIImage *image2 = [self blackAndWhite:image0];
    UIImage *image3 = [self exploseAddress:image0];
    UIImage *image4 = [self blurImage:image0];

    self.filterImages = [[NSArray alloc] initWithObjects:image0, image1, image2, image3, image4, nil];
    items = [NSMutableArray array];
    //setup scrollview
    for ( int i = 0; i < 5; i++ ) {
        ILSideScrollViewItem *item = [ILSideScrollViewItem item];
        item.defaultBackgroundImage = [self.filterImages objectAtIndex:i];
        NSLog(@"filter image is %@", item.defaultBackgroundImage);
        [item setTarget:self action:@selector(showFilterEffect:) withObject:item];
        [items addObject:item];
    }
    [self.scroller populateSideScrollViewWithItems:items];
}

// show filter effect on targetImageView
-(void)showFilterEffect:(ILSideScrollViewItem *)item{
    NSInteger index = [items indexOfObject:item ];
//    self.targetImage.image = [self.filterImages objectAtIndex:index];
    if( index == 0){
        self.targetImage.image =self.passedImage;
    } else if (index == 1) {
        self.targetImage.image = [self sepia:self.passedImage];
    }else if( index == 2  ){
        self.targetImage.image = [self blackAndWhite:self.passedImage];
    }else if( index == 3 ){
        self.targetImage.image = [self exploseAddress:self.passedImage];
    }else if(index == 4){
        self.targetImage.image = [self blurImage:self.passedImage];
    }
}
// filter effect
- (UIImage*)sepia:(UIImage*)originalImage{
    CIImage *beginImage = [[CIImage alloc] initWithImage:originalImage];
    CIFilter *filter = [CIFilter filterWithName:@"CISepiaTone" keysAndValues:kCIInputImageKey, beginImage, @"inputIntensity", @0.8, nil];
    CIImage *outputImage = [filter outputImage];
   
    CIContext *context = [CIContext contextWithOptions:nil];
    CGImageRef cgimg = [context createCGImage:outputImage fromRect:[outputImage extent]];
     UIImage *filteredImage = [UIImage imageWithCGImage:cgimg];
    return filteredImage;
}
// filter effect
- (UIImage*)blackAndWhite:(UIImage*)originalImage{

    CIImage *beginImage = [[CIImage alloc] initWithImage:originalImage];
    
    CIImage *blackAndWhite = [CIFilter filterWithName:@"CIColorControls" keysAndValues:kCIInputImageKey, beginImage, @"inputBrightness", [NSNumber numberWithFloat:0.0], @"inputContrast", [NSNumber numberWithFloat:1.1], @"inputSaturation", [NSNumber numberWithFloat:0.0], nil].outputImage;
    CIImage *output = [CIFilter filterWithName:@"CIExposureAdjust" keysAndValues:kCIInputImageKey, blackAndWhite, @"inputEV", [NSNumber numberWithFloat:0.7], nil].outputImage;
    
    CIContext *context = [CIContext contextWithOptions:nil];
    CGImageRef cgiimage = [context createCGImage:output fromRect:output.extent];
    UIImage *filteredImage = [UIImage imageWithCGImage:cgiimage];
    
    CGImageRelease(cgiimage);
    
    return filteredImage;

}
// filter effect
-(UIImage*)exploseAddress:(UIImage*)originalImage{
    CIImage *beginImage = [[CIImage alloc] initWithImage:originalImage];
    CIFilter *exposureAdjustmentFilter = [CIFilter filterWithName:@"CIExposureAdjust"];
    [exposureAdjustmentFilter setDefaults];
    [exposureAdjustmentFilter setValue:beginImage forKey:@"inputImage"];
    [exposureAdjustmentFilter setValue:[NSNumber numberWithFloat:0.4f] forKey:@"inputEV"];
    CIImage *outputImage = [exposureAdjustmentFilter valueForKey:@"outputImage"];
    CIContext *context = [CIContext contextWithOptions:nil];
    CGImageRef cgimg = [context createCGImage:outputImage fromRect:[outputImage extent]];
    UIImage *filteredImage = [UIImage imageWithCGImage:cgimg];
    return filteredImage;
}
// filter effect
-(UIImage*)blurImage:(UIImage*)originalImage{
    CIImage *beginImage = [[CIImage alloc] initWithImage:originalImage];
    CIContext *context = [CIContext contextWithOptions:nil];
    
    CIFilter *filter = [CIFilter filterWithName:@"CIGaussianBlur"
                                  keysAndValues: kCIInputImageKey, beginImage,
                        @"inputRadius", [NSNumber numberWithFloat:1.0], nil];
    
    CIImage *result = [filter valueForKey:kCIOutputImageKey];
    CGImageRef cgImage = [context createCGImage:result
                                       fromRect:[result extent]];

    UIImage *filteredImage = [UIImage imageWithCGImage:cgImage];
    return filteredImage;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark buttonController
// setup button controller
- (IBAction)addSomething:(id)sender {
    //the button that brings the items into view was pressed
    if (sender == self.addButton) {
		[self.radialMenu buttonsWillAnimateFromButton:sender withFrame:self.addButton.frame inView:self.view];
	}
}

#pragma mark - radial menu delegate methods
- (NSInteger) numberOfItemsInRadialMenu:(ALRadialMenu *)radialMenu {
	//FIXME: dipshit, change one of these variable names
	if (radialMenu == self.radialMenu) {
		return 5;
	} 
	return 0;
}


- (NSInteger) arcSizeForRadialMenu:(ALRadialMenu *)radialMenu {
	if (radialMenu == self.radialMenu) {
		return 180;
	} 
	return 0;
}


- (NSInteger) arcRadiusForRadialMenu:(ALRadialMenu *)radialMenu {
	if (radialMenu == self.radialMenu) {
		return 80;
	} 
	return 0;
}
// set image for each button
- (UIImage *) radialMenu:(ALRadialMenu *)radialMenu imageForIndex:(NSInteger) index {
	if (radialMenu == self.radialMenu) {
		if (index == 1) {
			return [UIImage imageNamed:@"facebook500.png"];
		} else if (index == 2) {
			return [UIImage imageNamed:@"save.png"];
		} else if (index == 3) {
			return [UIImage imageNamed:@"pen.png"];
		} else if (index == 4) {
			return [UIImage imageNamed:@"information.png"];
		} else if (index == 5 ) {
            return [UIImage imageNamed:@"library.png"];
        }
	} 
	return nil;
}
// setup button with its coresponding method
- (void) radialMenu:(ALRadialMenu *)radialMenu didSelectItemAtIndex:(NSInteger)index {
	if (radialMenu == self.radialMenu) {
		[self.radialMenu itemsWillDisapearIntoButton:self.addButton];
		if (index == 1) {
            NSLog(@"facebook");
			[self facebook];
		} else if (index == 2) {
            NSLog(@"saveImage");
			[self saveImage];
		} else if (index == 3) {
			[self draw];
		} else if ( index == 4 ){
            [self showInfo];
        } else if ( index == 5 ){
            NSLog(@"save to photo libiary");
            [self saveToPhotoLibrary];
        }
	}
}
// alow user draw on photo
- (void)draw {
    // Create a painting view
    _paintView = [[PaintView alloc] initWithFrame:self.targetImage.bounds];
    self.paintView.lineColor = [UIColor grayColor];
    self.paintView.delegate = self;
    [self.view addSubview:self.paintView];
    self.shouldMerge = NO;
}

#pragma mark infobutton
// show instruction page
- (void)showInfo {
    DetailInfoViewController *controller = [[DetailInfoViewController alloc] init];
    [controller presentInParentViewController:self];
}
// share photo to friends via facebook
- (void)facebook{
    if([SLComposeViewController isAvailableForServiceType:SLServiceTypeFacebook]){
        SLComposeViewController * controller = [SLComposeViewController composeViewControllerForServiceType:SLServiceTypeFacebook];
        [controller addImage:self.targetImage.image];
        [self.navigationController pushViewController:controller animated:NO];
    }
}
// upload image to parse 
-(void)saveImage{
    //save self.targetImage.image to Parse
    NSData* imageData = nil;
    if (self.paintView != nil ) {
        NSLog(@"save paintview");
        CGRect rect = self.targetImage.bounds;
        
        [self mergePaintToBackgroundView:rect];
        imageData = [NSData dataWithData:UIImagePNGRepresentation(self.targetImage.image)];
    }else {
        NSLog(@"no paintview");
        imageData = [NSData dataWithData:UIImagePNGRepresentation(self.targetImage.image)];
    }
    [self addObjectToParse:imageData];
}

// save an image of both targetImage and drawing to photo library
- (void)saveToPhotoLibrary{
    if (self.paintView != nil ) {
        NSLog(@"save paintview");
        CGRect rect = self.targetImage.bounds;
        [self mergePaintToBackgroundView:rect];
    }else {
        NSLog(@"no paintview");
    }
    UIImageWriteToSavedPhotosAlbum( self.targetImage.image, nil, nil, nil );
    UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Photo Saved" message:nil delegate:nil cancelButtonTitle:@"OK" otherButtonTitles: nil];
    [alertView show];
}



#pragma mark paintView
// merge photo with users drawing
- (void)paintView:(PaintView*)paintView finishedTrackingPath:(CGPathRef)path inRect:(CGRect)painted
{
    if (self.shouldMerge) {
        [self mergePaintToBackgroundView:painted];
    }
}

/*******************************************************************************
 * @method          mergePaintToBackgroundView
 * @abstract        Combine the last painted image into the current background image
 * @description
 *******************************************************************************/
- (void)mergePaintToBackgroundView:(CGRect)painted
{
    // Create a new offscreen buffer that will be the UIImageView's image
    CGRect bounds = self.targetImage.bounds;
    UIGraphicsBeginImageContextWithOptions(bounds.size, NO, self.targetImage.contentScaleFactor);
    CGContextRef context = UIGraphicsGetCurrentContext();
    
    // Copy the previous background into that buffer.  Calling CALayer's renderInContext: will redraw the view if necessary
    CGContextSetBlendMode(context, kCGBlendModeCopy);
    [self.targetImage.layer renderInContext:context];
    
    // Now copy the painted contect from the paint view into our background image
    // and clear the paint view.  as an optimization we set the clip area so that we only copy the area of paint view
    // that was actually painted
    CGContextClipToRect(context, painted);
    CGContextSetBlendMode(context, kCGBlendModeNormal);
    [self.paintView.layer renderInContext:context];
    [self.paintView erase];
    
    // Create UIImage from the context
    UIImage *image = UIGraphicsGetImageFromCurrentImageContext();
    self.targetImage.image = image;
    UIGraphicsEndImageContext();
    
    // Save the image to the photolibrary
    NSData *data = UIImagePNGRepresentation(image);
    UIImageWriteToSavedPhotosAlbum([UIImage imageWithData:data], nil, nil, nil);
    
    // Save the image to the photolibrary in the background
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        NSData *data = UIImagePNGRepresentation(image);
        UIImageWriteToSavedPhotosAlbum([UIImage imageWithData:data], nil, nil, nil);
        
        dispatch_async(dispatch_get_main_queue(), ^{
            NSLog(@"\n>>>>> Done saving in background...");//update UI here
        });
    });
}
// upload image to parse
-(void)addObjectToParse:(NSData *) imageData {
    PFObject *object = [PFObject objectWithClassName:@"images"];
    PFFile *imageFile = [PFFile fileWithData:UIImagePNGRepresentation(self.targetImage.image)];
   
    [object setObject:imageFile forKey:@"image"];
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    NSString * username = [defaults objectForKey:@"userName"];
    [object setObject:username forKey:@"userName"];
    //    [object save];
    [object saveInBackgroundWithBlock:^(BOOL succeeded, NSError *error) {
        if (!error) {
//            [self refresh];
            NSLog(@"save object %@", object);
        }
        else{
            // Log details of the failure
            NSLog(@"Error: %@ %@", error, [error userInfo]);
        }
    }];
}

// add image to current view
- (IBAction)tagToAddImage:(UITapGestureRecognizer *)sender {
    NSLog(@"in tagToAddImage");
    CGPoint locationInView = [sender locationInView:self.view];
    NSLog(@"\ntap location: x:%5.2f y:%5.2f",locationInView.x,locationInView.y);
    UIImageView * addView = [[UIImageView alloc] initWithImage:addImage];
    addView.userInteractionEnabled = YES;
    [self.view addSubview:addView];
}


#pragma mark face detection
-(void)findFaces:(UIImageView *)imageView
{
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        
        CIImage *image = [[CIImage alloc] initWithImage:imageView.image];
        
        NSString *accuracy = CIDetectorAccuracyHigh;
        NSDictionary *options = [NSDictionary dictionaryWithObject:accuracy forKey:CIDetectorAccuracy];
        CIDetector *detector = [CIDetector detectorOfType:CIDetectorTypeFace context:nil options:options];
        NSArray *features = [detector featuresInImage:image];
        
        dispatch_async(dispatch_get_main_queue(), ^{
            [self drawImageAnnotatedWithFeatures:features];
        });
        
    });
}
// test method for face detection, by draw circle on face
- (void)drawImageAnnotatedWithFeatures:(NSArray *)features {
    
	UIImage *faceImage = self.passedImage;
    UIGraphicsBeginImageContextWithOptions(faceImage.size, YES, 0);
    [faceImage drawInRect:self.targetImage.bounds];
    
    // Get image context reference
    CGContextRef context = UIGraphicsGetCurrentContext();
    
    // Flip Context
    CGContextTranslateCTM(context, 0, self.targetImage.bounds.size.height);
    CGContextScaleCTM(context, 1.0f, -1.0f);
    
    CGFloat scale = [UIScreen mainScreen].scale;
    
    if (scale > 1.0) {
        // Loaded 2x image, scale context to 50%
        CGContextScaleCTM(context, 0.5, 0.5);
    }
    
    for (CIFaceFeature *feature in features) {
        
        CGContextSetRGBFillColor(context, 0.0f, 0.0f, 0.0f, 0.5f);
        CGContextSetStrokeColorWithColor(context, [UIColor whiteColor].CGColor);
        CGContextSetLineWidth(context, 2.0f * scale);
        CGContextAddRect(context, feature.bounds);
        CGContextDrawPath(context, kCGPathFillStroke);
        
        // Set red feature color
        CGContextSetRGBFillColor(context, 1.0f, 0.0f, 0.0f, 0.4f);
        
        if (feature.hasLeftEyePosition) {
            [self drawFeatureInContext:context atPoint:feature.leftEyePosition];
        }
        
        if (feature.hasRightEyePosition) {
            [self drawFeatureInContext:context atPoint:feature.rightEyePosition];
        }
        
        if (feature.hasMouthPosition) {
            [self drawFeatureInContext:context atPoint:feature.mouthPosition];
        }
    }
    
    self.targetImage.image = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
}

- (void)drawFeatureInContext:(CGContextRef)context atPoint:(CGPoint)featurePoint {
    CGFloat radius = 20.0f * [UIScreen mainScreen].scale;
    CGContextAddArc(context, featurePoint.x, featurePoint.y, radius, 0, M_PI * 2, 1);
    CGContextDrawPath(context, kCGPathFillStroke);
}
@end
