//
//  HomeViewController.m
//  assignment3
//
//  Created by Ninglin Li on 5/10/13.
//  Copyright (c) 2013 Ninglin_Li. All rights reserved.
//

#import "HomeViewController.h"
#import "DetailViewController.h"
# import "LabelViewController.h"

@interface HomeViewController ()

@end

@implementation HomeViewController

// get user information such as username from NSUserDefault
- (void)viewWillAppear:(BOOL)animated{
    self.images = [[NSMutableArray alloc] init];
    self.objectsArray = [[NSArray alloc] init];
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    self.username = [defaults objectForKey:@"userName"];
    NSLog(@"%@", self.username);
    if ( self.username == nil ) {
        [self getUsername];
    }
	[self loadImageFromParse];
//    NSLog(@" after load images %@", self.images);
//     NSLog(@"objectArray is %@", self.objectsArray);
}

- (void)viewDidLoad
{
    [super viewDidLoad];
}


# pragma mark collection view
-(NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section{
    NSLog(@" self array %@", self.objectsArray);
    return self.objectsArray.count;
}

-(NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView{
    return 1;
}

-(UICollectionViewCell*)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath{
    NSLog(@"in cell for item at index path method");
    NSLog(@"index %@, %d", [self.objectsArray objectAtIndex:indexPath.row], indexPath.row);
    static NSString *identifier = @"MyCell";
    UICollectionViewCell * cell = [collectionView dequeueReusableCellWithReuseIdentifier:identifier forIndexPath:indexPath];
  
  // get image from parse and show in cell
    UIImageView *userPhoto = (UIImageView *)[cell viewWithTag:100];
    PFFile *theImage = [[self.objectsArray objectAtIndex:indexPath.row] objectForKey:@"image"];
    NSData *imageData = [theImage getData];
    userPhoto.image = [UIImage imageWithData:imageData];
    NSLog(@"image is %@, %d", userPhoto.image, indexPath.row);
    return cell;
}
// show detailview by segue
-(void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender{
    NSLog(@"In segue ");
    if( [[segue identifier] isEqualToString:@"DetailViewSegue"] ){
        UICollectionViewCell* cell = (UICollectionViewCell *)sender;
        NSIndexPath *selectedIndexPath = [self.collectionView indexPathForCell:cell];
        NSLog(@"%d", selectedIndexPath.row);
        DetailViewController * detailViewController = [segue destinationViewController];
        detailViewController.passedImage = [self.images objectAtIndex:selectedIndexPath.row];
        NSLog(@"detailviewcontroller passimage is %@", detailViewController.passedImage);
    }
}

#pragma mark set username
// if there is not username in NSUserDefault, which probably means the first time the user use this app
// ask for username
-(void)getUsername{
    UIAlertView * alert = [[UIAlertView alloc] initWithTitle:@"" message:@"Please enter your name:" delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"OK", nil];
    alert.alertViewStyle = UIAlertViewStylePlainTextInput;
    UITextField * textField = [alert textFieldAtIndex:0];
    textField.placeholder = @"Enter your name";
    textField.keyboardType = UIKeyboardTypeNumberPad;
    [alert show];
    
}
// save username in NSUserDefault
- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex {
    UITextField * textField = [alertView textFieldAtIndex:0];
    if ([textField.text length] <= 0 || buttonIndex == 0){
        return; //If cancel or 0 length string the string doesn't matter
    }
    if (buttonIndex == 1) {
        self.username = textField.text;
        NSLog(@"%@", self.username);
        NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
        [defaults setObject:self.username forKey:@"userName"];
    }
}


#pragma mark parse
// get all user's images from parseand store in self.images
-(void)loadImageFromParse{
    PFQuery *query = [PFQuery queryWithClassName:@"images"];
    [query whereKey:@"userName" equalTo:self.username];
    [query orderByAscending:@"createdAt"];
//    query.cachePolicy = kPFCachePolicyNetworkElseCache;
    [query findObjectsInBackgroundWithBlock:^(NSArray *objects, NSError *error){
        if( !error){
            self.count = objects.count;
            self.objectsArray = objects;
            NSLog(@"Successfully get %d images", self.objectsArray.count);
            for (PFObject * theObject in objects) {
                PFFile *theImage = [theObject objectForKey:@"image"];
                NSData *imageData = [theImage getData];
                UIImage *image = [UIImage imageWithData:imageData];
                [self.images addObject: image];
            }
            NSLog(@"in loadImage from parse after load images %@", self.images);
        }
        else{
            NSLog(@"Error: %@, %@", error, [error userInfo]);
        }
        [self.collectionView reloadData];
    }];
   
}

// load image to parse
-(void)addObjectToParse:(NSData *) imageData {
    PFObject *object = [PFObject objectWithClassName:@"images"];
    PFFile *imageFile = [PFFile fileWithData:imageData];
    [object setObject:imageFile forKey:@"image"];
    [object setObject:self.username forKey:@"userName"];

    [object saveInBackgroundWithBlock:^(BOOL succeeded, NSError *error) {
        if (!error) {
            [self refresh];
        }
        else{
            // Log details of the failure
            NSLog(@"Error: %@ %@", error, [error userInfo]);
        }
    }];
    NSLog(@"save object %@", object);
}

- (void)setUpImages:(NSArray *)images
{
    // This method sets up the downloaded images and places them nicely in a grid
    dispatch_queue_t queue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);
    dispatch_async(queue, ^{
        self.images = [NSMutableArray array];
        // Iterate over all images and get the data from the PFFile
        for (int i = 0; i < images.count; i++) {
            PFObject *eachObject = [images objectAtIndex:i];
            PFFile *theImage = [eachObject objectForKey:@"image"];
            NSData *imageData = [theImage getData];
            UIImage *image = [UIImage imageWithData:imageData];
            [self.images addObject:image];
        }
    });
}

// reload collectionview data with updated images data from parse
-(void)refresh{
    [self loadImageFromParse];
    [self.collectionView reloadData];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark get photo from library or camera
// add image from camera or photo library
- (IBAction)addImage:(id)sender {
    UIActionSheet *actSheet = [[UIActionSheet alloc] initWithTitle: @"Please choose your photo" delegate:self cancelButtonTitle:nil destructiveButtonTitle: nil otherButtonTitles:@"Photo library", @"Take a picture", nil];
    [actSheet showInView:[UIApplication sharedApplication].keyWindow];
}

// actionSheet delegate, if user press "Photo library", go to open photo library
// if user press "Take a picture", open camera
-(void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex{
    NSLog(@"in action sheet");
   
    NSString *buttonTitle = [actionSheet buttonTitleAtIndex:buttonIndex];
    if  ([buttonTitle isEqualToString:@"Photo library"]) {
        NSLog(@"Photo library button in actionSheet is pressed ");
        [self photoAlbur];
    }
    else if ([buttonTitle isEqualToString:@"Take a picture"]) {
        NSLog(@"Take a picture button in actionSheet is pressed");
        [self photoCamera];
    }
}

// choose image from photo library
-(void)photoAlbur{
    
    if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypePhotoLibrary]) {
        UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
        // tell the UIImagePickerController to send messages to this view controller
        imagePicker.delegate = self;
        imagePicker.allowsEditing = YES;
        imagePicker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
        // show image picker on the screen
        [self presentViewController:imagePicker animated:YES completion:^{
            NSLog(@"Image picker was presented");}
         ];
    }else{
        UIAlertView *alert = [[UIAlertView alloc]
                              initWithTitle:@"Error accessing photo library"
                              message:@"Device does not support a photo library"
                              delegate:nil
                              cancelButtonTitle:@"OK"
                              otherButtonTitles:nil];
        [alert show];
    }
}
// choose image by take a photo
-(void)photoCamera{
    if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) {
        UIImagePickerController* imagePicker = [[UIImagePickerController alloc] init];
        imagePicker.delegate = self;
        imagePicker.sourceType = UIImagePickerControllerSourceTypeCamera;
        imagePicker.modalTransitionStyle = UIModalTransitionStyleCoverVertical;
        imagePicker.allowsEditing = YES;
        [self presentViewController:imagePicker animated:YES completion:^{
            NSLog(@"Image picker was presented");}
         ];
    }
    else {
        UIAlertView *alert = [[UIAlertView alloc]
                              initWithTitle:@"Sorry"
                              message:@"Device does not support camera"
                              delegate:nil
                              cancelButtonTitle:@"OK"
                              otherButtonTitles:nil];
        [alert show];
    }
}
// add image to parse from the source that the user choose
-(void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info{
    NSLog(@"Image selected: %@", info);
    
    //Get picked image from info dictionary
    UIImage *image = [info objectForKey:UIImagePickerControllerOriginalImage];
  
    // Set our currentImage property to the selected Image

    NSData *imageData = [NSData dataWithData:UIImagePNGRepresentation(image)];
    // save image to parse
    [self addObjectToParse: imageData];
    
        // Take image picker off the screen
    [[self presentedViewController] dismissViewControllerAnimated:YES completion:^{
        NSLog(@"Image picker was dismissed");
    }];
    
}
// show labelview
- (IBAction)getInstruction:(id)sender {
    LabelViewController *controller = [[LabelViewController alloc] init];
    [controller presentInParentViewController:self];
}
@end
